
RWStructuredBuffer<float4> Output : BACKBUFFER;
StructuredBuffer<float4> ValueBuffer; 
StructuredBuffer<uint> indexBuffer;
float threadCount, spreadCount;


float bSize (StructuredBuffer<uint> buffer)
{
	uint count, dummy;	
	buffer.GetDimensions(count,dummy);
	return count;
}
float bSize (StructuredBuffer<float4> buffer)
{
	uint count, dummy;	
	buffer.GetDimensions(count,dummy);
	return count;
}
float bLoad(StructuredBuffer<uint> valueBuffer, float defaultValue, float dtid)
{
	float value = defaultValue;
	uint count = bSize(valueBuffer);
	if (count > 0) value = valueBuffer[dtid.x % count];
	return value;
}
float3 bLoad(StructuredBuffer<float4> valueBuffer, float3 defaultValue, float dtid)
{
	float3 value = defaultValue;
	uint count = bSize(valueBuffer);
	if (count > 0) value = valueBuffer[dtid.x % count];
	return value;
}



[numthreads(64,1,1)]
void CS(uint3 dtid : SV_DispatchThreadID)
{
	if (dtid.x >= threadCount) { return; }
	
	float index = indexBuffer[dtid.x];
	Output[index] = ValueBuffer[dtid.x % bSize(ValueBuffer)];
}



technique11 BuildBuffer
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}


